# AGMS Gateway Lua Sample Code

The AGMS Gateway Lua Sample Code provides example to execute Transactions on the AGMS Gateway.

## Dependencies

LuaSOAP version >= 3.0.0 (https://github.com/tomasguisasola/luasoap)
LuaExpat version >= 1.3.0 (http://matthewwild.co.uk/projects/luaexpat)
LuaSocketgit version >= 3.0-rc1 (https://github.com/diegonehab/luasocket)
LuaSec version >= 0.4.1 (https://github.com/brunoos/luasec)

The libraries are included in the lib folder. Please note the luasec-0.5.0 do not work on Centos environment.


## Package Dependencies:
Ubuntu:lua-dev, libexpat-dev, openssl-devel
CentOS: lua-devel, expat-devel, openssl-dev


## Compile Instructions

The libexpat can be built using the `make`. Upload the libexpat folder on your developement  server and issue `make` command.

The luasocket can be built and installed using make. Upload the luasocket library on your development machine and issue `make {PLATEFORM}` and then `make install`. Please note the path of CDIR - path to *.so files and LDIR - path to lua files. These need to be updated in the lua script

The luasec can be built using the make. Upload the libsec-0.4 folder on your developement  server and issue `make` command



## Path Lua and C Libraries

The correct path of these libraries (Lua & C) needs to be set in the run.lua for them to work. 


## License

See the LICENSE file.




