#!/usr/bin/lua
-- Agms Module to interact with the Agms Gateway

-- @author: Maanas Royy
-- @copyright: Avant-Garde Marketing Solutions, Inc.

agms = {}

	-- Request Object
	agms.Request = {}
	agms.Request.TransactionType = ""
    agms.Request.GatewayUserName = ""
    agms.Request.GatewayPassword = ""
    agms.Request.PaymentType = ""
    agms.Request.Amount = ""
    agms.Request.Tax = ""
    agms.Request.Shipping = ""
    agms.Request.OrderDescription = ""
    agms.Request.OrderID = ""
    agms.Request.PONumber = ""
    agms.Request.CCNumber = ""
    agms.Request.CCExpDate = ""
    agms.Request.CVV = ""
    agms.Request.CheckName = ""
    agms.Request.CheckABA = ""
    agms.Request.CheckAccount = ""
    agms.Request.AccountHolderType = ""
    agms.Request.AccountType = ""
    agms.Request.SecCode = ""
    agms.Request.FirstName = ""
    agms.Request.LastName = ""
    agms.Request.Company = ""
    agms.Request.Address1 = ""
    agms.Request.Address2 = ""
    agms.Request.City = ""
    agms.Request.State = ""
    agms.Request.Zip = ""
    agms.Request.Country = ""
    agms.Request.Phone = ""
    agms.Request.Fax = ""
    agms.Request.EMail = ""
    agms.Request.Website = ""
    agms.Request.ShippingFirstName = ""
    agms.Request.ShippingLastName = ""
    agms.Request.ShippingCompany = ""
    agms.Request.ShippingAddress1 = ""
    agms.Request.ShippingAddress2 = ""
    agms.Request.ShippingCity = ""
    agms.Request.ShippingState = ""
    agms.Request.ShippingZip = ""
    agms.Request.ShippingCountry = ""
    agms.Request.ShippingEmail = ""
    agms.Request.ShippingPhone = ""
    agms.Request.ShippingFax = ""
    agms.Request.ProcessorID = ""
    agms.Request.TransactionID = ""
    agms.Request.Tracking_Number = ""
    agms.Request.Shipping_Carrier = ""
    agms.Request.IPAddress = ""
    agms.Request.Track1 = ""
    agms.Request.Track2 = ""
    agms.Request.Track3 = ""
    agms.Request.Track_Type = ""
    agms.Request.Custom_Field_1 = ""
    agms.Request.Custom_Field_2 = ""
    agms.Request.Custom_Field_3 = ""
    agms.Request.Custom_Field_4 = ""
    agms.Request.Custom_Field_5 = ""
    agms.Request.Custom_Field_6 = ""
    agms.Request.Custom_Field_7 = ""
    agms.Request.Custom_Field_8 = ""
    agms.Request.Custom_Field_9 = ""
    agms.Request.Custom_Field_10 = ""
    agms.Request.SAFE_Action = ""
    agms.Request.SAFE_ID = ""
    agms.Request.ReceiptType = ""
    agms.Request.MICR = ""
    agms.Request.MICRSymbolSet = ""
    agms.Request.CheckFrontTIFF = ""
    agms.Request.CheckBackTIFF = ""
    agms.Request.CheckNumber = ""
    agms.Request.Terminal_ID = ""
    agms.Request.CCNumber2 = ""
    agms.Request.Clerk_ID = ""
    agms.Request.Billing_Code = ""
    agms.Request.InvoiceID = ""
    agms.Request.BatchID = ""
    agms.Request.DLNumber = ""
    agms.Request.DLState = ""
    agms.Request.IdentityVerification = ""
    agms.Request.CourtesyCardID = ""
    agms.Request.MagData = ""

    -- Response Object
    agms.Response = {}
    agms.Response.STATUS_CODE = ""
    agms.Response.STATUS_MSG = ""
    agms.Response.TRANS_ID = ""
    agms.Response.AUTH_CODE = ""
    agms.Response.AVS_CODE = ""
    agms.Response.AVS_MSG = ""
    agms.Response.CVV2_CODE = ""
    agms.Response.CVV2_MSG = ""
    agms.Response.ORDERID = ""
    agms.Response.SAFE_ID = ""
    agms.Response.FULLRESPONSE = ""
    agms.Response.POSTSTRING = ""
    agms.Response.BALANCE = ""
    agms.Response.GIFTRESPONSE = ""
    agms.Response.MERCHANT_ID = ""
    agms.Response.CUSTOMER_MESSAGE = ""


    -- AgmsAPI method
    agms.AgmsAPI = {}
    agms.AgmsAPI.url = "https://gateway.agms.com/roxapi/agms.asmx"

    function agms.AgmsAPI.ProcessTransaction (request)

    	-- Fabricate the SOAP Request Body
    	local request_body = {tag = "objparameters"}
    	for key, val in pairs(request) do
    		if val ~= "" then
    			table.insert(request_body, { tag = key, val})
    		end
    	end
    	
    	-- Soap Call, Important part add the namespace
    	local ns, meth, ent = agms.soap_client.call(
    		{url = agms.AgmsAPI.url,
    		namespace =  "https://gateway.agms.com/roxapi/",
    		soapaction = "https://gateway.agms.com/roxapi/ProcessTransaction",
    		method = "ProcessTransaction",
    		entries = {request_body}
    		})
    	
    	return ns, meth, ent
    	
    end


return agms